class Wave
{
  int drawCount = 0;  
  
  int centerHeight;
  
  int xspacing    = 1;   // How far apart should each horizontal location be spaced
  int maxXSpacing = 128;
  
  int w;              // Width of entire wave
  
  float theta = 0.0;  // Start angle at 0
  float amplitude = 75.0;  // Height of wave
  float period = 500.0;  // How many pixels before the wave repeats
  float dx;  // Value for incrementing X, a function of period and xspacing
  float[] yvalues;  // Using an array to store height values for the wave
  
  float circleSize = 4;
  
  Wave(int centerHeight_)
  {
    centerHeight = centerHeight_;
    w = width+16;
    dx = (TWO_PI / period) * xspacing;  
    yvalues = new float[w/xspacing];
  }
  
  void updatePeriod(float period_)
  {
    period = period_;
    dx = (TWO_PI / period) * xspacing;  
  }
  
  void draw()
  {
    drawCount++;
    if (mousePressed) {
      if (drawCount % 10 == 0) {
        xspacing = min(xspacing+1, maxXSpacing);
      }
    } else {
      xspacing = 1; 
    }    
    
    calcWave();
    renderWave();
  }
  
  void calcWave()
  {
    // Increment theta (try different values for 'angular velocity' here
    theta += 0.02;
  
    // For every x value, calculate a y value with sine function
    float x = theta;
    for (int i = 0; i < yvalues.length; i++) {
      yvalues[i] = sin(x)*amplitude;
      x+=dx;
    } 
  }
  
  void renderWave() 
  {
    noStroke();
    fill(189, 231, 240);
    // A simple way to draw the wave with an ellipse at each location
    for (int x = 0; x < yvalues.length; x++) {
      ellipse(x*xspacing, centerHeight+yvalues[x], circleSize, circleSize);
  }
}
}
